org.apache.commons.net.discard

## Class DiscardUDPClient

- java.lang.Object
- - org.apache.commons.net.DatagramSocketClient
  - - org.apache.commons.net.discard.DiscardUDPClient

- All Implemented Interfaces:
    AutoCloseable
  Direct Known Subclasses:
    EchoUDPClient

      public class DiscardUDPClient
      extends DatagramSocketClient

  The DiscardUDPClient class is a UDP implementation of a client for the Discard protocol described in RFC 863. To use the class, just open a local UDP port with `open` and call `send` to send datagrams to the server After you're done sending discard data, call `close()` to clean up properly.
  See Also:
    `DiscardTCPClient`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_PORT` The default discard port.

    - ### Fields inherited from class org.apache.commons.net.DatagramSocketClient

      `_isOpen_, _socket_, _socketFactory_, _timeout_`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DiscardUDPClient()` Constructs a new instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `send(byte[] data, InetAddress host)` Same as {@code send(data, data.length, host.
    `void` | `send(byte[] data, int length, InetAddress host)` Same as {@code send(data, length, host.
    `void` | `send(byte[] data, int length, InetAddress host, int port)` Sends the specified data to the specified server at the specified port.

    - ### Methods inherited from class org.apache.commons.net.DatagramSocketClient

      `checkOpen, close, getCharset, getDefaultTimeout, getLocalAddress, getLocalPort, getSoTimeoutDuration, isOpen, open, open, open, setCharset, setDatagramSocketFactory, setDefaultTimeout, setSoTimeout`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PORT

          public static final int DEFAULT_PORT

      The default discard port. It is set to 9 according to RFC 863.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DiscardUDPClient

          public DiscardUDPClient()

      Constructs a new instance.

  - ### Method Detail

    - #### send

          public void send(byte[] data,
                           InetAddress host)
                    throws IOException

      Same as `send(data, data.length, host. DiscardUDPClient.DEFAULT_PORT)`.
      Parameters:
        `data` - the buffer to send
        `host` - the target host
      Throws:
        `IOException` - if an error occurs
      See Also:
        `send(byte[], int, InetAddress, int)`

    - #### send

          public void send(byte[] data,
                           int length,
                           InetAddress host)
                    throws IOException

      Same as `send(data, length, host. DiscardUDPClient.DEFAULT_PORT)`.
      Parameters:
        `data` - the buffer to send
        `length` - the length of the data in the buffer
        `host` - the target host
      Throws:
        `IOException` - if an error occurs
      See Also:
        `send(byte[], int, InetAddress, int)`

    - #### send

          public void send(byte[] data,
                           int length,
                           InetAddress host,
                           int port)
                    throws IOException

      Sends the specified data to the specified server at the specified port.
      Parameters:
        `data` - The discard data to send.
        `length` - The length of the data to send. Should be less than or equal to the length of the data byte array.
        `host` - The address of the server.
        `port` - The service port.
      Throws:
        `IOException` - If an error occurs during the datagram send operation.